#include "utils.PRO2"
#include "Estudiant.hpp"
#include "vect_est_io.cpp"

#include <vector>
#include <set>


int compta_presentats_repes(vector<Estudiant> &vest)
{
  int cont=0;
  for (int i=0; i<vest.size(); ++i) {
    /*mirem si vest[i] t nota*/
    if (vest[i].te_nota()) {
      ++cont; 
    }	
  }
  return cont;
}
//retorna el nombre d'estudiants amb nota
//si hi ha repetits els compta tots els cops

int compta_presentats_error(vector<Estudiant> &vest)
{
  int cont=0;
  for (int i=0; i<vest.size(); ++i) {
    /*mirem si vest[i] t nota*/
    if (vest[i].te_nota()) {
      int j=0;
      // mirem si el DNI de vest[i] ha sortit abans
      while (vest[i].consultar_DNI() != vest[j].consultar_DNI()) ++j;
      if (j==i) ++cont; 
    }	
  }
  return cont;
}
//retorna el nombre d'estudiants amb nota
//si hi ha repetits no els compta.
//esta malament ja que si la primera aparici no tena nota tampoc el compta

int compta_presentats(vector<Estudiant> &vest)
{
  int cont=0;
  for (int i=0; i<vest.size(); ++i) {
    /*mirem si vest[i] t nota*/
    if (vest[i].te_nota()) {
      int j=0;
      // mirem si el DNI de vest[i] ha sortit abans
      while (vest[i].consultar_DNI() != vest[j].consultar_DNI() or 
	     !vest[j].te_nota()) ++j;
      if (j==i) ++cont; 
    }	
  }
  return cont;
}
//retorna el nombre d'estudiants amb nota
//si hi ha repetits no els compta.


int compta_presentats_set(vector<Estudiant> &vest)
{
  set<int> sdni;
  for (int i=0; i<vest.size(); ++i) {
    /*mirem si vest[i] t nota*/
    if (vest[i].te_nota()) {
      sdni.insert(vest[i].consultar_DNI());
    }	
  }
  return sdni.size();
}
//retorna el nombre d'estudiants amb nota
//si hi ha repetits no els compta.

int main()
{
  vector < Estudiant > v;
  leerVector(v);
  

  cout << endl;
  cout << "Hi ha " << compta_presentats_repes(v) << " presentats" << endl;
  cout << "Hi ha " << compta_presentats_error(v) << " presentats" << endl;
  cout << "Hi ha " << compta_presentats(v) << " presentats" << endl;
  cout << "Hi ha " << compta_presentats_set(v) << " presentats" << endl;
}

